#include "i2c.h"
//------------------------------------------------

void InitI2C(void)
{
  TRISC=0x18;//RC3 and RC4 Input (SDC and SDA)
  // SSPM3:SSPM0 = 1000 (I2C Master mode, clock = FOSC/(4 * (SSPADD + 1))
  // = 4000000/(4 * (9 + 1)) = 100000 Hz)
  // CKE=0(Disable SMBus specific inputs)
  // SKP=1(Release clock)
  // SMP=1 (Slew rate control disabled for standard speed mode (100 kHz and 1 MHz))
  // SSPEN= 1 (Enables the serial port and configures the SDA and SCL pins as the serial port pins)
  SSPADD=0X09;
  SSPSTAT = 0x80; // Slew Rate control is disabled
  SSPCON = 0x38; // Select and enable I2C in master mode
}
//------------------------------------------------
void I2C_Idle()
{
  while(READ_WRITE);
  ZERO=0;
  while(ZERO)
  {
    SSPCON2&0x1f;
  }
}
//------------------------------------------------
void I2C_IntWait(void)
{
  while(!SSPIF);
  SSPIF=0;
}
//------------------------------------------------
void I2C_StartCondition(void)
{
  I2C_Idle();
  SEN=1;
  I2C_IntWait();
}
//------------------------------------------------
void I2C_StopCondition(void)
{
  PEN = 1;
  I2C_IntWait();
}
//------------------------------------------------
bit I2C_Write_Byte(unsigned char Byte)
{
  SSPBUF = Byte;
  I2C_IntWait();
  return ACKSTAT;
}
//------------------------------------------------
void I2C_SendByteByADDR(unsigned char c,unsigned char addr)
{
  I2C_StartCondition();
  I2C_Write_Byte(addr);
  I2C_Write_Byte(c);
  I2C_StopCondition();
}
//------------------------------------------------
